# explainableVariance.py
#
# Bryan Daniels
# 6.26.2017
#
# Estimate "unexplainable variance" as the variance within bins of similar
# laser input.
#

import scipy
from toolbox.binning import findBinIndices,quantileBins


def unexplainableStdev(data,inputvals,numbins):
    """
    data has shape (# trials)x(# times)
    inputvals has shape (# trials)
    
    returns array of same shape as data containing stdevs calculated over
    values at that timepoint and within the same input bin
    """
    if len(data) != len(inputvals): raise Exception
    
    binIndices = findBinIndices(inputvals,numbins)

    stdData = scipy.empty_like(data)

    for indices in binIndices:
        stdsBin = scipy.std(data[indices],axis=0,ddof=1)
        
        print "len(indices) =",len(indices)
        
        for i in indices:
            stdData[i] = stdsBin

    return stdData


